//==========================================================================
//	Author				: Cytron Technologies		
//	Project				: Sending Data using RF Module
//	Project description	: The transmitter will send 0->F (data in Hexadecimal)
//==========================================================================
//	include
//===================================================================================
#include <pic.h> 

//	configuration
//===================================================================================
__CONFIG (0x3F32);

//	define
//===================================================================================
#define	inc_button	RA1
#define dec_button 	RA2
#define	send_button	RA3
#define display		PORTB	

//	function prototype
//===================================================================================
void uart_send(unsigned char data);

//	main function
//===================================================================================
void main(void)
{
	//assign variable
	unsigned char num,no;
										//7 segment display
	unsigned char _7seg[16]={0b01111111,0b00001101,0b10110111,0b10011111,	//0,1,2,3
							 0b11001101,0b11011011,0b11111011,0b00001111,	//4,5,6,7
							 0b11111111,0b11011111,0b11101111,0b11111001,	//8,9,A,B
							 0b01110011,0b10111101,0b11110011,0b11100011};	//C,D,E,F

	ADCON1= 0x06;				//configure PortA as digital I/O

	TRISA = 0b111111;			//configure PORTA input
	TRISB = 0b00000000;			//configure PORTB as output
	
	//setup USART
	BRGH = 0;					//baud rate low speed option
	SPBRG = 255;				//set boud rate to 1200bps for 20Mhz crystal 
	TX9 = 0;					//8-bit transmission
	TXEN = 1;					//enable transmission
	SYNC = 0;					//asynchronous
	
	SPEN = 1;					//enable serial port
	
	num=0;    
	no=0;
	display=_7seg[num];

	while(1)						//infinity loop
	{
		if(inc_button==0)			//increase number per press
		{
			if(num==15) num=0;		//back to 0 after F
			else num+=1;			//one increment

			display=_7seg[num];		//display number on 7 segment

			while(inc_button==0)	
				uart_send(no);		//continuous send data
		}
	
		else if(dec_button==0)		//decrease number per press
		{
			if(num==0) num=15;		//go to F after 0
			else num-=1;			//one decrement

			display=_7seg[num];		//display number on 7 segment

			while(dec_button==0)
				uart_send(no);		//continuous send data
		}

		else if(send_button==0)		//send the desired number	
			no=num;

		uart_send(no);				//continuous send data
	}		
}

//	functions
//===================================================================================
void uart_send(unsigned char data)
{	
	while(TXIF==0);				//only send the new data after 
	TXREG=data;					//the previous data finish sent
}

